;*************************************************************************
;*                      COM PORT  MEGHAJT MODUL                         *
;*                  Copyright(c) Bognr Andrs 2007                      *
;*       Legjabb verzi ami nem hasznl megszaktsokat s BIOS-t       *
;*              Ezrt mkdik mind DOS s Windows alatt                  *
;*************************************************************************
;   The source code of COM handling
;   COM port hardware level handling
;   Module is used in Borland C, use "com.h"
;   Only COM1 or COM2 can be used but only one at a time!

[BITS 16]		;Set code generation to 16 bit mode
[SEGMENT .text]		;Main code segment
GLOBAL _initcom		;initialize a COM port
GLOBAL _adas		;transmit a data
GLOBAL _vetel		;receive a data
GLOBAL _restore		;restore the interrupt
GLOBAL _state		;give the state byte of the port
GLOBAL _restore		;restores IT-s this module doesn't use this

port dw 0	     	;COM port base address
status db 0		;status byte of the port

;   initialize the port
;   Only one port can be used at a time!
_initcom:
push bx
push dx
push ds
push es
push bp
mov ax,cs		;ds=cs=es
mov ds,ax
mov es,ax
mov bp,sp
mov ax,[bp+14]		;com paramter
cmp al,1
jz com1
cmp al,2
jz com2
jmp init_err
com1:
mov ax,3F8h		;port no.
jmp x01
com2:
mov ax,2F8h		;port no.
x01:
push cs
pop ds
mov [port],ax
mov dx,ax
			;COM ads-vtelre programozsa
add dx,4
mov al,0Ch
out dx,al		;MCR: out2=0 IT letiltva

mov dx,[port]
mov al,80h
add dx,3
out dx,al		;LCR: DLA=1->divisor latch bersa jn

mov ax,[bp+16]		;oszt paramter
mov dx,[port]		;divisor latch(16bit)
out dx,al		;divisor latch LSB be

add dx,1
mov al,ah
out dx,al		;divisor latch MSB be

mov dx,[bp+18]		;parity paramter
cmp dx,2
ja init_err
mov bx,[bp+20]		;stop paramter
dec bx
cmp bx,1
ja init_err
mov ax,[bp+22]		;width paramter
sub ax,5
cmp ax,3
ja init_err
push cx
mov cx,2
shl bl,cl
or al,bl
mov dh,dl
mov cx,4
shl dl,cl
or al,dl
mov cx,2
shl dh,cl
pop cx
not dh
and dh,08h
or al,dh
and al,1Fh
mov dx,[port]
add dx,3
out dx,al		;LCR: DLA=0-> data registerek i/o

mov dx,[port]
inc dx
mov al,00h
out dx,al		;IER: sszes IT letiltva
			;ad state olv,adatklds
mov dx,[port]
add dx,5
in al,dx

mov dx,[port]		;00h kldse
mov al,00h
out dx,al		;(nha kimegy a legels byte nha nem)

mov ax,0		;result
jmp x02
init_err:		;hibs paramterek vannak megadva
mov ax,2
x02:
pop bp
pop es
pop ds
pop dx
pop bx
retf

;  Send a character
_adas:
push ax
push dx
push ds
push bp
mov bp,sp
mov ax,cs
mov ds,ax
var1:			;Vrs mg kimegy az adat
mov dx,[port]		;Sttuszreg-re vr
add dx,5
in al,dx
and al,60h
cmp al,60h
jnz var1
kiugr:
mov dx,[port]		;ads
mov ax,[bp+12]		;data paramter
out dx,al
pop bp
pop ds
pop dx
pop ax
retf

;  Receive a character
_vetel:
push dx
push ds
mov ax,cs
mov ds,ax
mov dx,[port]		;sttusz olv.
add dx,5
in al,dx
mov [status],al		;save status
mov ah,al
and al,1Ch		;rfutsi hibt nem veszi szre (FATAL!!!)
jz ok2
mov dx,[port]           ;"dummy" port olvass
in al,dx
mov ax,0ffffh		;hiba esetn -1-el visszatr
jmp x03
nodata:
mov dx,[port]           ;"dummy" port olvass
in al,dx
mov ax,0fffeh		;nincs adat->-2-vel tr vissza
jmp x03
ok2:
and ah,01h	       	;sttuszreg: van-e adat?
jz nodata
mov dx,[port]		;adat kiolvassa
in al,dx
mov ah,0
x03:
pop ds
pop dx
retf

;  Give the status register of the port
_state:
push ds
mov ax,cs
mov ds,ax
mov al,[status]
mov ah,0
pop ds
retf

_restore:
retf