;*************************************************************************
;*                      COM PORT  MEGHAJT MODUL                         *
;*                  Copyright(c) Bognr Andrs 2006                      *
;*************************************************************************
;   The source code of COM handling
;   COM port hardware level handling

;COM port meghajt modul amely hasznl IT-ket, ezrt Windowsban nem futtathat!
;C modul, hasznlja a com.h-t.

.model large
.code
public _initcom		;initialize a COM port
public _adas		;transmit a data
public _vetel		;receive a data
public _restore		;restore the interrupt
public _state		;give the state byte of the port

vec1 dd 0		;COM1 mszak vektorok
mask1 db 0		;megszak mask
rf db 1			;receiver flag: 1 ha jtt adat
tf db 1			;transmitter flag: 1 ha adhat
port dw 0	     	;COM port base address
status db 0		;status byte of the port

inte:			;COM1 megszaktsi rutin
cli
push ax
push dx
push ds
mov ax,cs	       	;ds=cs
mov ds,ax
mov al,20h   		;EOI
out 20h,al
mov dx,[port]	      	;IIR: milyen IT volt?
add dx,2
in al,dx
cmp al,02h		;res THR: ads engedlyezs
jz adas
cmp al,04h		;adat vtele
jz vetel
jmp itvege
adas:			;ads eng.
mov al,1
mov [tf],al	       	;TF=1
jmp itvege
vetel:			;vtel
mov al,1
mov [rf],al		;RF=1
itvege:
pop ds
pop dx
pop ax
sti
iret

_initcom proc far
push bx
push dx
push ds
push es
push bp
mov ax,cs		;ds=cs=es
mov ds,ax
mov es,ax
mov bp,sp
mov ax,[bp+14]		;com paramter
cmp al,1
jz com1
cmp al,2
jz com2
jmp init_err
com1:
cli 			;com1 megszak
xor ax,ax
mov ds,ax
mov ax,ds:[0ch*4]
mov es:word ptr[vec1],ax
mov ax,ds:[0ch*4+2]
mov es:word ptr[vec1+2],ax
mov ax,offset inte
mov ds:[0ch*4],ax
mov ax,cs
mov ds:[0ch*4+2],ax
mov ax,cs
mov ds,ax
mov al,21h		;mszak.mask lekrdezs
mov al,21h
mov [mask1],al
and al,0EFh            	;megszak maskok belltsa
out 21h,al		;COM1 engedve
sti
mov ax,3F8h		;port no.
jmp x01
com2:
cli 			;com2 megszak
xor ax,ax
mov ds,ax
mov ax,ds:[0bh*4]
mov es:word ptr[vec1],ax
mov ax,ds:[0bh*4+2]
mov es:word ptr[vec1+2],ax
mov ax,offset inte
mov ds:[0bh*4],ax
mov ax,cs
mov ds:[0bh*4+2],ax
mov al,21h		;mszak.mask lekrdezs
mov al,21h
mov [mask1],al
and al,0F7h            	;megszak maskok belltsa
out 21h,al		;COM1 engedve
sti
mov ax,2F8h		;port no.
x01:
push cs
pop ds
mov [port],ax
mov dx,ax
			;COM ads-vtelre programozsa
add dx,4
mov al,08h
out dx,al		;MCR: out2=1 IT engedve

mov dx,[port]
mov al,80h
add dx,3
out dx,al		;LCR: DLA=1->divisor latch bersa jn

mov ax,[bp+16]		;oszt paramter
mov dx,[port]		;divisor latch(16bit): 500Hz belltsa
out dx,al		;divisor latch LSB be

add dx,1
mov al,ah
out dx,al		;divisor latch MSB be

mov dx,[bp+18]		;parity paramter
cmp dx,2
ja init_err
mov bx,[bp+20]		;stop paramter
dec bx
cmp bx,1
ja init_err
mov ax,[bp+22]		;width paramter
sub ax,5
cmp ax,3
ja init_err
push cx
mov cx,2
shl bl,cl
or al,bl
mov dh,dl
mov cx,4
shl dl,cl
or al,dl
mov cx,2
shl dh,cl
pop cx
not dh
and dh,08h
or al,dh
and al,1Fh
mov dx,[port]
add dx,3
out dx,al		;LCR: DLA=0-> data registerek i/o

mov dx,[port]
inc dx
mov al,03h
out dx,al		;IER: IT ha adat vtele,adsa utn
			;ad state olv,adatklds
mov dx,[port]
add dx,5
in al,dx

mov dx,[port]		;00h kldse
mov al,00h
out dx,al		;nha kimegy a legels byte nha nem

mov ax,0		;result
jmp x02
init_err:		;hibs paramterek vannak megadva
mov ax,2
x02:
pop bp
pop es
pop ds
pop dx
pop bx
retf
_initcom endp

_adas proc far
push ax
push dx
push ds
push bp
mov bp,sp
mov ax,cs
mov ds,ax
var1:			;Vrs mg kimegy az adat
mov al,[tf]
cmp al,1
jz kiugr
mov dx,[port]		;Sttuszreg-re vr
add dx,5
in al,dx
and al,60h
cmp al,60h
jnz var1
kiugr:
xor ax,ax		;TF=0
mov [tf],al
mov dx,[port]		;ads
mov ax,[bp+12]		;data paramter
out dx,al
pop bp
pop ds
pop dx
pop ax
retf
_adas endp

_vetel proc far
push dx
push ds
mov ax,cs
mov ds,ax
mov dx,[port]		;sttusz olv.
add dx,5
in al,dx
mov [status],al		;save status
mov ah,al
and al,1Ch		;rfutsi hibt nem veszi szre (FATAL!!!)
jz ok1
mov ax,0ffffh		;hiba esetn -1-el visszatr
jmp x03
ok1:
mov al,[rf]		;van-e vett adat?
cmp al,1
jz ok2
nodata:
mov ax,0fffeh		;nincs adat->-2-vel tr vissza
jmp x03
ok2:
and ah,01h	       	;sttuszreg: van-e adat?
jz nodata
mov dx,[port]		;adat kiolvassa
in al,dx
mov ah,0
x03:
mov dl,0
mov [rf],dl		;RF=0
pop ds
pop dx
retf
_vetel endp

_restore proc far
push ax
push dx
push ds
push es
mov dx,[port]		;Melyik port?
cmp dx,3F8h		;com1?
jnz r_com2

cli			;COM1 mszak vektor visszalltsa
xor ax,ax
mov ds,ax
push cs
pop es
mov ax,es:word ptr[vec1]
mov ds:[0ch*4],ax
mov ax,es:word ptr[vec1+2]
mov ds:[0ch*4+2],ax
mov al,[mask1]      	;port lemaszkolsa
or al,10h
;out 21h,al
sti
jmp vege1

r_com2:
cli			;COM2 mszak vektor visszalltsa
xor ax,ax
mov ds,ax
push cs
pop es
mov ax,es:word ptr[vec1]
mov ds:[0bh*4],ax
mov ax,es:word ptr[vec1+2]
mov ds:[0bh*4+2],ax
mov al,[mask1]      	;port lemaszkolsa
or al,08h
;out 21h,al
sti

vege1:
pop es
pop ds
pop dx
pop ax
retf
_restore endp

_state proc far
push ds
mov ax,cs
mov ds,ax
mov al,[status]
mov ah,0
pop ds
retf
_state endp
end