#include <conio.h>
#include <stdio.h>
#include <graphics.h>
#include <math.h>
#include "bfile.h"
//Digital Signal Processing with 1024dot DFT

//16 bit MONO
extern void dft1024();// 1024 pontos DFT 16bit szlessg
extern void idft1024();//1024 pontos Inverz DFT 16bit szlessg

int hk[1024];
float amp[1024];
float fi[1024];
float re[1024];
float im[1024];

const int N=1024;    	//Number of dots
const int df=20;      	//Shifting delta f (pontegysg amp kar.-n)
//Window1
const int Wsize1=200; 	//Trapezoid window size (size of rising edge)
const int offs1=20;	//Trapezoid rising edge funct. offset
//Window2
const int Wsize2=100; 	//Trapezoid window size (size of rising edge)
const int offs2=0;	//Trapezoid rising edge funct. offset

//Bejv mintk ablakozsa
void window1(){//Windowing samples, trapezoid window
  int x;
  float m=1/(float)Wsize1;//emelk. meredeksg
  float res;
  for(x=0;x<Wsize1;x++){
    res=(float)hk[x]*m*(float)(x+offs1);
    hk[x]=res;
  }
  for(x=0;x<Wsize1;x++){
    res=(float)hk[N-x-1]*m*(float)(x+offs1);
    hk[N-x-1]=res;
  }
}

//Kimen mintk ablakozsa
void window2(){//Windowing samples, trapezoid window
  int x;
  float m=1/(float)Wsize2;//emelk. meredeksg
  float res;
  //hanger llts
  for(x=0;x<1024;x++){
    res=(float)hk[x]*0.7; hk[x]=res;
  }
  for(x=0;x<Wsize2;x++){
    res=(float)hk[x]*m*(float)(x+offs2);
    hk[x]=res;
  }
  for(x=0;x<Wsize2;x++){
    res=(float)hk[N-x-1]*m*(float)(x+offs2);
    hk[N-x-1]=res;
  }
}

void main(){
int f,g;//FILE
int x,y,z;
float fx;
clrscr();
printf("Digital Signal Processing with 1024dot DFT \n");
f=openr("source.wav");if(ferr()){printf("File error\n");exit(0);}
g=openw("dest.wav");
for(x=0;x<100;x++){//header
  y=read(f); write(y,g);
}
z=1;
while(!endf()){
  for(x=0;x<1024;x++){
    hk[x]=read(f)-128;
    if(endf())hk[x]=0;
  }
//  window1();//windowing1
  dft1024();
  //Mvelet a DFT trben
  //Frequency shifting
  for(x=511-df;x>-1;x--){ amp[x+df]=amp[x];fi[x+df]=fi[x]; }
  for(x=0;x<df;x++){ amp[x]=0;fi[x]=0;}
  for(x=512+df;x<1024;x++){ amp[x-df]=amp[x];fi[x-df]=fi[x];}
  for(x=1024-df;x<1024;x++){ amp[x]=0;fi[x]=0;}
  //Filtering
  for(x=400;x<1024;x++){
    amp[x]=((3.0/1024.0)*(float)(x-300)+1.0)*amp[x];
  }
  //Visszatranszformls
  idft1024();
  window2();//windowing2
  for(x=0;x<1024;x++)write(hk[x]+128,g);//kirs
  printf("%d kB ksz  ",z++);
}

closefile(f);
closefile(g);
}