;****************************************************************
;  Robot controlling module
;  Copyright(c) Bognar Andras 2007 01.
;  Puts PWM signals out from LPT port
;****************************************************************

;LPT port=378H
[BITS 16]		;Set code generation to 16 bit mode
[SEGMENT .text]		;Main code segment

GLOBAL _init            ;initialize the timer hardware
GLOBAL _restore         ;restore the interrupts

EXTERN _pwm0            ;PWM duty cycle (bit no. on LPT) [0..255]
EXTERN _pwm1            ;int pwm0,pwm1,pwm2
EXTERN _pwm2
EXTERN _talp            ;Talpmotor: 0-stop, 1-right, -1-left rotation

cpy db 'Copyright(c) Bognr Andrs 2006',0
mszak dd 0
mask db 0
dsertek dw 0            ;ds regiszter rtke inicializcikor

_init:                  ;idztre ls, 50Hz-re tprogramozsa
push ax
push es
cli
;save ds
mov ax,ds
mov [cs:dsertek],ax
;set interrupts
push ds
mov ax,cs
mov es,ax
xor ax,ax
mov ds,ax
mov ax,[08h*4]
mov [es:mszak],ax
mov ax,[08h*4+2]
mov [es:mszak+2],ax
mov ax,inte
mov [08h*4],ax
mov [08h*4+2],cs
pop ds
;set IT mask
in al,21h
in al,21h
mov [es:mask],al
and al,0feh
out 21h,al
;program the timer
mov al,36h  ;0. oszt; 2 byte rs,olv.,MODE3
out 43h,al;  0011 0110
mov al,0F8h
out 40h,al  ;idztre als byte
jmp d3
d3:
mov al,5Ch
out 40h,al  ;idztre fels byte
;kilps
sti
pop es
pop ax
retf

_restore:               ;restore interrupt
cli
push ax
;restore IT
push ds
push es
mov ax,cs
mov es,ax
xor ax,ax
mov ds,ax
mov ax,[es:mszak]
mov [08h*4],ax
mov ax,[es:mszak+2]
mov [08h*4+2],ax
pop es
pop ds
;restore IT mask
mov al,[mask]
out 21h,al
;restore timer
mov al,36h  ;0. oszt; 2 byte rs,olv.,MODE3
out 43h,al;  0011 0110
mov al,69h
out 40h,al  ;idztre als byte
jmp d333
d333:
mov al,0ffh
out 40h,al  ;idztre fels byte
;end
pop ax
sti
retf

inte:
cli
push ax
push bx
push cx
push dx
push si
push di
push ds
;load ds
mov ax,[cs:dsertek]
mov ds,ax
;EOI
mov al,20h
out 20h,al
;set LPT bits
mov dx,378h
mov al,13h
mov bx,[_talp]

cmp bx,1
jz elore
cmp bx,0ffffh
jz hatra
v01:
xor bx,bx
mov bl,al          ;bx= ami a porton kinn vann
out dx,al
jmp u01
elore:
or al,04h
jmp v01
hatra:
or al,08h
jmp v01
u01:
;PWM hosszak levrsa
mov cx,[_pwm0]       ;cx= pwm0
mov si,[_pwm1]       ;si= pwm1
mov di,[_pwm2]       ;di= pwm2
cikl3:
call delay
dec cx
dec si
dec di
cmp cx,0
jz stop0
ell0:
cmp si,0
jz stop1
ell1:
cmp di,0
jz stop2
ell2:
test bx,13h   ;all bits==0?
jnz cikl3
jmp u02
stop0:        ;zero the bits
and bl,0feh
mov al,bl
out dx,al
jmp ell0
stop1:
and bl,0fdh
mov al,bl
out dx,al
jmp ell1
stop2:
and bl,0efh
mov al,bl
out dx,al
jmp ell2
u02:
;end
pop ds
pop di
pop si
pop dx
pop cx
pop bx
pop ax
sti
iret

;ksleltets
delay:
push cx
mov cx,130
cikl1:
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
loop cikl1
pop cx
ret
