#include <stdio.h>
#include "bfile.h"

//speech shifter 16 s 8 bitre
extern int zero8(int data);       	/*Shows the periods 8bit*/
extern int zero16(int data);     	/*Shows the periods 16bit*/
extern void setup(int min,int max);	/*Set the min and max variables*/

//File handling
int f,g;
char fname[80];
int w;

//A program konfigurcis adatai (shift.cnf)
int bits=16;	//8-8bites, 16-16 bites wav file
int u_d=1; 	//1=felfel shiftels, 0=lefel shiftels
int perno=1; 	//hanyadik peridust vgjuk ki vagy tbbszrstsk
int datno=2; 	//hanyadik adatbyte-ot vegyk ki vagy tbbszrstsk
int mul=3; 	//peridus multiplikcik szma
//Egyb kiegsztk s mdostk (nem ajnlott vltoztatni)
int min=281;	//peridus vgsi als kszb.   min=1/tmin
int max=147;	//peridus vgsi fels kszb.  max=1/tmax
int told=0;	//kiegszt toldalkbyte-ok a fjl vgre
//Lebegtets(FM modulci szinuszos jellel)
int mod=0;	//1-lebegtets bekapcsolva, 0-*nincs
int wfreq;	//lebegtetsi peridusid
int wamp;	//lebegtetsi amplitd

//Wave file attribtumok
unsigned long hossz=0;//filehossz
unsigned int tomtip;//tmrtsi tpus
unsigned int csat;//csatornk szma
unsigned int frekv;//mintavteli frekvencia
unsigned int bps;//bjt/sec
unsigned long dblock=0;//adatblokk hossza
int bit16=1;//16 bites -e a wav  !!!Nem a headerbl szedve!

//Shiftels segdvltozi
int cper=0;  /*peridus szmll*/
int cdat=0;  /*byte szmll*/
int kivag=0; /*Kivgs*/
int betesz=0;/*Bettel*/
char*ppmst;  //Peridus puffer kezdete
char*ppm;    //Peridus puffer futpointer
int size;    //PP size ttltse
int x,y;     /*general*/
int eof=0;   //end of file

//Ki s bevitel 16 bit
int input(){//16 bites bevitel
  int res,x;
  res=read(f); if(endf())eof=1; x=read(f); if(endf())eof=1;
  asm{	mov ax,res
	mov bx,x
	mov ah,bl
	mov res,ax
  }return res;
}
void output(int x){//16 bites kivitel
  int x1,x2;
  asm{	mov ax,x
	xor bx,bx
	mov bl,ah 	//ax=als, bx=fels
	xor ah,ah
	mov x1,ax
	mov x2,bx
  }write(x1,g);write(x2,g);
}

//SZTEREO hozztolds kezd
unsigned int left;//Globlis adatok
unsigned int right;
long mdat=0;	//Modulci adatszmllja
int dir=0;	//Modulci irnya
void modulate(){//FM modulci
  mdat++;
  if(mdat>wfreq){
    mdat=0; if(!dir){datno--;if(datno<1){datno=1;dir=1;}}
	    else{datno++;if(datno>wamp){datno--;dir=0;}}
  }
}
void in8s(){//8bit stereo beolvass
  left=read(f);if(endf())eof=1;right=read(f);if(endf())eof=1;
  if(mod)modulate();
}
void in16s(){//16bit stereo beolvass
  left=input();right=input();
  if(mod)modulate();
}
void out8s(){//8bit stereo kimenet
  write(left,g);write(right,g);
}
void out16s(){//16bit stereo kimenet
  output(left);output(right);
}
void stereo(void(*in)(),void(*out)()){
  int*ppmst;  //Peridus puffer kezdete
  int*ppm;    //Peridus puffer futpointer
  if(u_d==2){    // Le shiftels
    while(!eof){ //Amg van
      (*in)();
      if(!kivag){if(zero16(left)){cper++;if(cper==perno){cper=0;kivag=1;}}
	(*out)();
	cdat++; if(cdat==datno){cdat=0;(*out)();}
      }
      else{if(zero16(left))kivag=0; }
    }
  }
  else{// Fel shiftels
    if((ppmst=allocate(256))==NULL){printf("Memory ERROR");exit(0);}
    //Period buffer
    cdat=0;cper=0;
    while(!eof){
      (*in)();
      cdat++;if(cdat!=datno)(*out)();else cdat=0;//minden datno-ikat kihagyni
      if(zero16(left)){ cper++;//zruspont + felfut l
	if(cper>perno-1){ size=0; ppm=ppmst;  cper=0;
	  do{(*in)();*ppm++=left;*ppm++=right;size++;}//size 4 byte-onknt n
	  while((size<1024)&&(!zero16(left)));
	  for(x=0;x<mul;x++){ppm=ppmst;
	    for(y=0;y<size;y++){ cdat++;
	      if(cdat!=datno){left=*ppm++;right=*ppm++;(*out)();}
	      else {cdat=0;ppm++;ppm++;}
	    }//for-end
	  }//for-end
	}//Zero point handling if-end
      }//Zero detecting if-end
    }//while-end
    mfree(ppmst);
  }//else vege
}
//SZTEREO hozztolds vge

//Shiftel rutinok (mainbl hvdnak) mind a 4 fajta shiftelshez
void shift16m(){//16bit mon
  int*ppmst;  //Peridus puffer kezdete
  int*ppm;    //Peridus puffer futpointer
  if(u_d==2){    /* Le shiftels */
    while(!eof){ /*Amg van*/
      w=input();
      if(!kivag){if(zero16(w)){cper++;if(cper==perno){cper=0;kivag=1;}}
	output(w);
	cdat++; if(cdat==datno){cdat=0;output(w);}
      }
      else{if(zero16(w))kivag=0; }
    }
  }
  else{/* Fel shiftels */
    if((ppmst=allocate(128))==NULL){printf("Memory ERROR");exit(0);}
    /*Period buffer =2048 byte(1024word)  but 1 period max 150 byte */
    cdat=0;cper=0;
    while(!eof){
      w=input();
      cdat++;if(cdat!=datno)output(w);else cdat=0;
      if(zero16(w)){ cper++;/*zruspont + felfut l*/
	if(cper>perno-1){ size=0; ppm=ppmst;  cper=0;
	  do{w=input(); *ppm++=w;size++;}while((size<1024)&&(!zero16(w)));
	  for(x=0;x<mul;x++){ppm=ppmst;
	    for(y=0;y<size;y++){ cdat++;
	      if(cdat!=datno)output(*ppm++);else {cdat=0;ppm++;}
	    }/*for-end*/
	  }/*for-end*/
	}/*Zero point handling if-end*/
      }/*Zero detecting if-end*/
    }/*while-end*/
    mfree(ppmst);
  }/*else vege*/
}
void shift16s(){//16bit stereo
  //printf("ERROR: Can't handle stereo files\n");
  stereo(&in16s,&out16s);
}
void shift8m(){//8bit mono
  if(u_d==2){    /* Le shiftels */
    while((w=read(f))!=-1){ /*Amg van*/
      if(!kivag){if(zero8(w)){cper++;if(cper==perno){cper=0;kivag=1;}}
	write(w,g);
	cdat++; if(cdat==datno){cdat=0;write(w,g);}
      }
      else{if(zero8(w))kivag=0; }
    }
  }
  else{/* Fel shiftels */
    if((ppmst=allocate(64))==NULL){printf("Memory ERROR");exit(0);}
    /*Period buffer =1024  but 1 period max 150 byte */
    cdat=0;cper=0;
    while((w=read(f))!=-1){
      cdat++;if(cdat!=datno)write(w,g);else cdat=0;
      if(zero8(w)){ cper++;/*zruspont + felfut l*/
	if(cper>perno-1){ size=0; ppm=ppmst;  cper=0;
	  do{w=read(f); *ppm++=w; size++;}while((size<1024)&&(!zero8(w)));
	  for(x=0;x<mul;x++){ppm=ppmst;
	    for(y=0;y<size;y++){ cdat++;
	      if(cdat!=datno)write(*ppm++,g); else {cdat=0;ppm++;}
	    }/*for-end*/
	  }/*for-end*/
	}/*Zero point handling if-end*/
      }/*Zero detecting if-end*/
    }/*while-end*/
    mfree(ppmst);
  }/*else vege*/
}
void shift8s(){//8bit stereo
  //printf("ERROR: Can't handle stereo files\n");
  stereo(&in8s,&out8s);
}

void linerr(int lineno){//Line error in config file
  closefile(f);
  printf("\nERROR in config file in line %d",lineno);exit(0);
}

void error(){//File format error
 printf("\nFATAL: File format error\n");exit(0);
}

int inscmp(char*s1,char*s2){//string compare
int a=0;  char c,d;         // s2-re kell hasonltani
do{c=s1[a];d=s2[a];a++;}
while((d)&&(c==d));
if(!d&&!c)return(1); else return(0);
}

int number(char*param){	/*Szm konvertlsa a paramterbl (0-32767)*/
int no=0;		/*Returns -1 if error*/
int a,b;
for(a=0;(a<5)&&(param[a]>47)&&(param[a]<58);a++){no=no*10+param[a]-48;}
if(param[a]!=' '&&(param[a]!=',')&&(param[a]!=0))return(-1);
else {for(b=0;b<78-a;b++)param[b]=param[b+a+1];return(no);}
}

void config(){//config fjl kiolvassa s rtelmezse
  char sor[100]; //Aktulis sor
  char vari[50];//rsz. vltoz neve
  char value[50];//s rtke
  int x,y,err=0,lineno=1;
  while(!endf()&&(read(f)!='*')){}//csillag keresse
  if(endf()){printf("\nInvalid config file format\n");exit(0);}//nincs
  else{while((!endf())&&(read(f)!=10)){}
       if(endf()){printf("\nInvalid config file format\n");exit(0);}
  }
  while(!endf()){
    x=0; while(!endf()&&(x<100)&&((sor[x++]=read(f))!=13)){}x--;//sorbe
    if((sor[0]>'0'-1)&&(sor[0]<'9'+1))return;
    if(sor[x]==13){if(read(f)!=10)err=1;}//10 beolvas
    if(err||(x>98))linerr(lineno);
    sor[x]=0;//string lezrs
    if((sor[0]!=0)&&(sor[0]!='/')){//nem res sor s nem megjegyzs
      x=0; while((x<50)&&(sor[x]!='=')){vari[x]=sor[x];x++;} vari[x]=0; x++;
      y=0; while((y<50)&&(sor[x])){value[y]=sor[x];x++;y++;} value[y]=0;
      if(inscmp(vari,"u_d")){
	if((u_d=number(value))==-1){linerr(lineno);exit(0);}
	if((u_d!=1)&&(u_d!=2)){linerr(lineno);exit(0);}}
      else if(inscmp(vari,"bits")){
	if((bits=number(value))==-1){linerr(lineno);exit(0);} }
      else if(inscmp(vari,"perno")){
	if((perno=number(value))==-1){linerr(lineno);exit(0);} }
      else if(inscmp(vari,"datno")){
	if((datno=number(value))==-1){linerr(lineno);exit(0);} }
      else if(inscmp(vari,"mul")){
	if((mul=number(value))==-1){linerr(lineno);exit(0);} }
      else if(inscmp(vari,"min")){
	if((min=number(value))==-1){linerr(lineno);exit(0);} }
      else if(inscmp(vari,"max")){
	if((max=number(value))==-1){linerr(lineno);exit(0);} }
      else if(inscmp(vari,"told")){
	if((told=number(value))==-1){linerr(lineno);exit(0);} }
      else if(inscmp(vari,"wfreq")){
	if((wfreq=number(value))==-1){linerr(lineno);exit(0);} }
      else if(inscmp(vari,"wamp")){
	if((wamp=number(value))==-1){linerr(lineno);exit(0);} }
      else if(inscmp(vari,"mod")){
	if((mod=number(value))==-1){linerr(lineno);exit(0);} }
      else linerr(lineno);
    }
  }
}

void namein(char*fnamex){//wav file name input
  int x;
  scanf("%s",fnamex);
  x=0; while(fnamex[x])x++; fnamex[x]='.';fnamex[x+1]='w';
  fnamex[x+2]='a';fnamex[x+3]='v';fnamex[x+4]=0;
}

void main(int argc,char*argv[]){
int w,q,x,y;
int fs=0;//fejlc byte szmll
unsigned int t[4];//temporary
char c=0;
clrscr();
printf("Speech shifter Copyright(c) Bognr Andrs 2006\n\n");

printf("Configuring the system\n");
f=openr("shift.cnf");
if(ferr()){printf("ERROR Config file is not found\n ");exit(0);}
config();
closefile(f);

// Parancssori formtum:   shift16 forrs nyel
if(argc<2){
  printf("Opening source file...\n");
  f=openr("source.wav");//Forrs megnyitsa
  if(ferr()){
    printf("Default Source file is not exist\n");
    printf("\nInput source file name: "); scanf("%s",fname);
    x=0; while(fname[x])x++; fname[x]='.';fname[x+1]='w';
    fname[x+2]='a';fname[x+3]='v';fname[x+4]=0;
    f=openr(&fname);
    if(ferr()){printf("File open ERROR");exit(0);}
  }
  printf("\n\nOpening destination file...");
  g=openr("dest.wav");
  if(!ferr()){//Nyel megnyitsa
    closefile(g);
    printf("\nDefault Destination file is already exist\n");
    printf("Overwrite? (y/n)"); while(kbhit())getch(); c=0;
    while((c!='y')&&(c!='n'))c=getch();

    if(c=='y'){
      g=openw("dest.wav");
      if(ferr()){printf("\nFile open ERROR");exit(0);}
    }
    else{
      printf("\nInput destination file name: "); scanf("%s",fname);
      x=0; while(fname[x])x++; fname[x]='.';fname[x+1]='w';
      fname[x+2]='a';fname[x+3]='v';fname[x+4]=0;
      g=openw(&fname);
      if(ferr()){printf("\nFile open ERROR");exit(0);}
    }
  }
  else{
    g=openw("dest.wav");
    if(ferr()){printf("ERROR writing the file");exit(0);}}
}
else if(argc==2){
  printf("Opening source file...");
  x=0; while(argv[1][x]){fname[x]=argv[1][x];x++;}
  fname[x]='.';fname[x+1]='w'; fname[x+2]='a';fname[x+3]='v';fname[x+4]=0;
  f=openr(&fname);//Forrs
  if(ferr()){printf("File open ERROR");exit(0);}
  printf("\n\nOpening destination file...");
  g=openr("dest.wav");
    if(!ferr()){//Nyel megnyitsa
    closefile(g);
    printf("\nDefault Destination file is already exist\n");
    printf("Overwrite? (y/n)"); while(kbhit())getch(); c=0;
    while((c!='y')&&(c!='n'))c=getch();
    if(c=='y'){
      g=openw("dest.wav");
      if(ferr()){printf("\nFile open ERROR");exit(0);}
    }
    else{
      printf("\nInput destination file name: "); scanf("%s",fname);
      x=0; while(fname[x])x++; fname[x]='.';fname[x+1]='w';
      fname[x+2]='a';fname[x+3]='v';fname[x+4]=0;
      g=openw(&fname);
      if(ferr()){printf("\nFile open ERROR");exit(0);}
    }
  }
  else{
    g=openw("dest.wav");
    if(ferr()){printf("ERROR writing the file");exit(0);}
  }
}
else{
  x=0; while(argv[1][x]){fname[x]=argv[1][x];x++;}//Forrs megnyitsa
  fname[x]='.';fname[x+1]='w'; fname[x+2]='a';fname[x+3]='v';fname[x+4]=0;
  f=openr(&fname);
  if(ferr()){printf("File open ERROR");exit(0);}
  x=0; while(argv[2][x]){fname[x]=argv[2][x];x++;}//Nyel megnyitsa
  fname[x]='.';fname[x+1]='w'; fname[x+2]='a';fname[x+3]='v';fname[x+4]=0;
  g=openw(&fname);
  if(ferr()){printf("File open ERROR");exit(0);}
}

printf("\n\nStart processing...\n");

// Forrs fejlcnek beolvassa s tmsolsa a nyelbe
write(w=read(f),g); fs++; if(endf()||(w!='R'))error();
write(w=read(f),g); fs++; if(endf()||(w!='I'))error();
write(w=read(f),g); fs++; if(endf()||(w!='F'))error();
write(w=read(f),g); fs++; if(endf()||(w!='F'))error();

for(x=3;x>-1;x--)write(t[x]=read(f),g);
for(x=0;x<4;x++){ hossz=hossz*256+t[x];}
fs+=4;
write(w=read(f),g);fs++;
while(!endf()&&w!='W'){write(w=read(f),g);fs++;}
if(endf())error();
write(w=read(f),g); fs++; if(endf()||(w!='A'))error();
write(w=read(f),g); fs++; if(endf()||(w!='V'))error();
write(w=read(f),g); fs++; if(endf()||(w!='E'))error();
write(w=read(f),g);fs++;
while(!endf()&&w!='f'){write(w=read(f),g);fs++;}
if(endf())error();
write(w=read(f),g); fs++; if(endf()||(w!='m'))error();
write(w=read(f),g); fs++; if(endf()||(w!='t'))error();
write(w=read(f),g); fs++; if(endf()||(w!=' '))error();
for(x=0;x<4;x++)write(read(f),g); fs+=4;
tomtip=(w=read(f))+(q=read(f))*256; write(w,g);write(q,g);
csat=(w=read(f))+(q=read(f))*256;   write(w,g);write(q,g);
frekv=(w=read(f))+(q=read(f))*256;  write(w,g);write(q,g);
bps=(w=read(f))+(q=read(f))*256;    write(w,g);write(q,g);
fs+=8;
write(w=read(f),g);fs++;
while(!endf()&&w!='d'){write(w=read(f),g);fs++;}
if(endf())error();
write(w=read(f),g); fs++; if(endf()||(w!='a'))error();
write(w=read(f),g); fs++; if(endf()||(w!='t'))error();
write(w=read(f),g); fs++; if(endf()||(w!='a'))error();
for(x=3;x>-1;x--)write(t[x]=read(f),g);
for(x=0;x<4;x++){ dblock=dblock*256+t[x];}
fs+=4;
//printf("Header hossz=%d\n",fs);
//printf("Mg berand=%d",hossz+8-dblock-fs);
for(x=0;x<hossz+8-dblock-fs;x++)write(read(f),g);

//Digitlis jelfeldolgozs
setup(frekv/min,frekv/max);//setup

if(u_d==1)printf("UpShifting: ");
if(u_d==2)printf("DownShifting: ");
if((bits==16)||(bits==8)){
  if((bits==16)&&(csat==1)){printf("16BIT MONO");shift16m();}
  if((bits==16)&&(csat==2)){printf("16BIT STEREO");shift16s();}
  if((bits==8)&&(csat==1)){printf("8BIT MONO");shift8m();}
  if((bits==8)&&(csat==2)){printf("8BIT STEREO");shift8s();}
}
else printf("\nERROR: bits=%d\n",bits);

for(x=0;x<200;x++)write(128,g);//Kitlts
for(x=0;x<told;x++)write(128,g);

closefile(f);closefile(g);
printf("\nSuccessfully terminated\n");
}