;***************************************************************
;*    Speech Shifter program  Copyright(c) Bognr Andrs 2006  *
;***************************************************************
.model large
.code
public _zero8		;Shows the zero points 8 bit
public _zero16  	;Shows the zero points 16 bit
public _setup		;Set the min and max variables

cpy db 'Speech shifter copyright(c) Bognr Andrs 2006',0
min dw 80		;edge is acceptable after minimum "min" sample
max dw 150		;edge must be after "max" sample
rdata db 0		;old data (last data)
upinit db 1		;Initial cycle flag
dcount dw 0		;data counter
;//stereo left
rdata16l dw 0		;old data (last data)
upinit16l db 1		;Initial cycle flag
dcount16l dw 0		;data counter


_zero8 proc far		;Shows the second(above) zero point of the function
push bp			;Returns 1 on rising edge  /!\  8bit version
mov bp,sp
inc [dcount]
mov ax,[bp+6]		;input data
mov ah,[upinit]
cmp ah,1
jz initz
mov ah,[rdata]		;AL=recent data  AH=old data
mov [rdata],al
cmp ah,128		;old data is below 128
jc ok1			;maybe OK
jmp no1
ok1:
cmp al,128		;recent data is above or equal 128
jc no1			;does not meet

mov ax,[dcount]		;There was a rising edge but after 100 data?
cmp ax,[min]
jc at10
xor ax,ax
mov [dcount],ax
mov ax,1		;OK
jmp vegez
at10:
xor ax,ax
jmp vegez

no1:			;not OK, there was not a rising edge
mov ax,[dcount]
cmp ax,[max]
ja at11
xor ax,ax
jmp vegez
at11:
xor ax,ax
mov [dcount],ax
mov ax,1
jmp vegez

initz:			;initialize
mov [rdata],al
mov al,0
mov [upinit],al
vegez:
pop bp
retf
_zero8 endp

_zero16 proc far	;16bit stereo
push bx
push bp			;Returns 1 on rising edge
mov bp,sp
inc [dcount16l]
mov ax,[bp+8]		;input data
mov bh,[upinit16l]
cmp bh,1
jz initz1
mov bx,[rdata16l]	;AX=recent data  BX=old data
mov [rdata16l],ax
cmp bx,0		;old data is below 0
jc ok11			;maybe OK
jmp no11
ok11:
cmp ax,0		;recent data is above or equal 0
jc no11			;does not meet
;//rising edge was detected:
mov ax,[dcount16l]	;There was a rising edge but after [min] data?
cmp ax,[min]
jc at101
xor ax,ax		;YES->There was a rising edge after [min]
mov [dcount16l],ax
mov ax,1		;OK
jmp vegez1		;END
at101:			;NO
xor ax,ax
jmp vegez1		;END
;//rising edge was not detected:
no11:			;not OK, there was not a rising edge
mov ax,[dcount16l]
cmp ax,[max]		;Are we before [max]?
ja at111
xor ax,ax		;YES
jmp vegez1		;END
at111:
xor ax,ax		;NO->There must be a rising edge.
mov [dcount16l],ax
mov ax,1
jmp vegez1      	;END
;//Initialize
initz1:			;initialize
mov [rdata16l],ax
mov al,0
mov [upinit16l],al
;//END
vegez1:
pop bp
pop bx
retf
_zero16 endp

_setup proc far		;setup the min and max variables
push ax
push bp
mov bp,sp
mov ax,[bp+8]		;min
mov [min],ax
mov ax,[bp+10]		;max
mov [max],ax
pop bp
pop ax
retf
_setup endp

end