 /*
Header file for Memory allocation and file operation
   Copyright(c) Bognr Andrs 2006
   Used in large modell
   for Digital Signal Processor programs
*/
extern char* allocate(int size);
/*		Allocate memory in the heap
		Size in paragraph(16bytes)
		Returns pointer to the allocated block
		else returns null on Error
*/
extern int mfree(char*poi);
/*		Frees the allocated memory in the heap
		poi is the pointer to the allocated memory
		Returns 1 if error occureed
*/
extern int openr(char*name);
/*		Open a file to read, name is the file name
		Returns with the file handle number
		See ferr() function
*/
extern int openw(char*name);
/*		Open a file to write, name is the  file name
		Returns with the file handle number
		See ferr() function
*/
extern int closefile(int fileno);
/*		Close the opened file
		Returns 1 if error occured
*/
extern int readb(int fileno,int size,char*buf);
/*		Read a block from the file
		fileno=file handle, size=filesize, buf=buffer pointer
		Returns the number of transfered bytes (0 if error)
		endf-> shows the end of file
		ferr-> shows file error (CF error)
*/
extern int writeb(int fileno,int size,char*buf);
/*              Write a block from the file
		fileno=file handle, size=filesize, buf=buffer pointer
		Returns 0 on error and if not the all bytes was written in
		ferr-> shows file error (CF error)
*/
extern int read(int fileno);
/*		Read a byte from the file
		fileno=file handle
		Returns -1 on error and if no byte was read(EOF)
*/
extern int write(int data,int fileno);
/*		Write a byte to the file
		fileno=file handle
		returns -1 on error and if no bytes was written in
*/
extern int ferr();
/*		File error. Returns 1 on error (set if CF==1)
		Used by read,write,lread,lwrite,openr,openw functions
		It shows the result of the last file operation
*/
extern int endf();
/*		returns 1 if end of file reached
		It shows the result of the last file operation
*/