;*************************************************************************
;*                      HANGKRTYA MEGHAJT MODUL                        *
;*                  Copyright(c) Bognr Andrs 2005                      *
;*************************************************************************
.model large
.code
public _initsound            ;int initsound();   AX=0 ->HIBA
public _restore              ;int restore();     AX=0 ->HIBA
public _play                 ;play(char*poi,int size);
public _allocate             ;allocate memory
public _mrename              ;rename memory area
public _mfree                ;free memory
public _dmastop              ;stop the DMA operation
public _dmacontinue          ;Continue the DMA operation
public _itstate              ;Ask if interrupt happened
public _openr                ;Open a file to read
public _openw                ;Open a file to write
public _closefile            ;Close an opened file
public _read                 ;Read from a file
public _write                ;write to the file
public _ferr                 ;Returns 1 if open error occured

freq dw 20000                ;sample frequency [Hz]
mszak dd 0                   ;int 0DH rgi rtke
itmask db 0                  ;interrupt mask
mem dw 0                     ;allocated memory segment
poi dw 0                     ;DMA puffer pointer
flag db 0                    ;Shows the it state
fileerr db 0                 ;File error flag (error->1)

inte:                        ;IRQ5 interrupt routine
push ax
push ds
push dx
mov ax,cs
mov ds,ax
mov al,1
mov [flag],al
cli
mov al,20h
out 20h,al
sti
mov dx,22Eh
in al,dx
pop dx
pop ds
pop ax
iret

_itstate proc far            ;Ask if interrupt happened
push ds
mov ax,cs                    ;AX=1 if happened
mov ds,ax
mov al,[flag]
mov ah,0
pop ds
retf
_itstate endp

delay:                       ;delay routine
push cx
mov cx,dx                    ;in: BX= bels ciklus, DX=kls ciklus
kesik2:
push cx
mov cx,bx
kesik1:
nop
nop
nop
nop
nop
nop
nop
loop kesik1
pop cx
loop kesik2
pop cx
ret

_initsound proc far          ;reset and control
push ds
push es
push bx
push cx
push dx
mov dx,226h              ;reset the sound card with ramp sign
mov al,1                 ;to the reset port ( /-\ )
out dx,al
push dx
mov bx,10
mov dx,10
call delay
pop dx
mov al,0
out dx,al
push dx
mov bx,10
mov dx,100
call delay               ;critical delay !
pop dx
mov dx,22Eh
in al,dx                 ;test the answer from the Card
test al,80H              ;Is the data output register full?
jz serr
mov dx,22Ah
in al,dx
cmp al,0AAh              ;Card has to give '0AAH' after reset
jnz serr
mov al,0e0h              ;test the dsp: Warning! It can crash here.
call writedsp
mov al,88h
call writedsp
call readdsp
cmp al,77h               ;DSP has to negate the input data
jnz serr
mov ax,4800h                 ;asking for 128kB memory
mov bx,8192
int 21h
jc serr                      ;ax=pointer
push cs
pop ds
mov [mem],ax
add ax,4096                  ;computing the DMA puffer address
mov dx,0                     ;DMAseg=((allocated_seg)div 4096)*4096
mov bx,4096
div bx
mul bx
mov [poi],ax                 ;save the pointer
cli                          ;Set interrupt vectors
xor ax,ax
mov ds,ax
push cs
pop es
mov ax,ds:[0Dh*4]
mov es:word ptr[mszak],ax
mov ax,ds:[0Dh*4+2]
mov es:word ptr[mszak+2],ax
mov ax,offset inte
mov ds:[0Dh*4],ax
mov ds:[0Dh*4+2],cs
push cs
pop ds                       ;set interrupt mask register
in al,21h
mov [itmask],al                ;save mask
and al,11011111b
out 21h,al                   ;set mask , IRQ5 = Enabled
sti
call speakeron
mov ax,1
pop dx
pop cx
pop bx
pop es
pop ds
retf
serr:
mov ax,0
pop dx
pop cx
pop bx
pop es
pop ds
retf
_initsound endp

_restore proc far            ;Restore all
push bx
push es
push ds
mov ax,4900h                 ;free
mov bx,[mem]                 ;Returns AX=0 if error occured
mov es,bx
int 21h
jc rerr
xor ax,ax                    ;restore interrupt vector
mov ds,ax
push cs
pop es
cli
mov ax,es:word ptr[mszak]
mov ds:[0Dh*4],ax
mov ax,es:word ptr[mszak+2]
mov ds:[0Dh*4+2],ax
mov ax,cs
mov ds,ax		     ;restore interrupt mask
mov al,[itmask]
out 21h,al
sti
mov ax,1
pop ds
pop es
pop bx
retf
rerr:
mov ax,0
pop ds
pop es
pop bx
retf
_restore endp

writedsp:                    ;al=data
push ax
varas1:
mov dx,22Ch
in al,dx
test al,80H
jnz varas1
pop ax
out dx,al
ret

readdsp:                     ;al=data
mov dx,22Eh
in al,dx
test al,80h
jz readdsp
mov dx,22Ah
in al,dx
ret

speakeron:
mov al,0D1h
call writedsp
ret

speakeroff:
mov al,0D3h
call writedsp
ret

_dmastop proc far            ;Stops the DMA operation
push ax
push dx
mov al,0D0h                  ;Stop DSP
call writedsp
mov al,05h                   ;Stop DMA
out 0Ah,al
mov dx,226h              ;reset the sound card with ramp sign
mov al,1                 ;to the reset port ( /-\ )
out dx,al
push dx
mov bx,10
mov dx,10
call delay
pop dx
mov al,0
out dx,al
mov bx,10
mov dx,100
call delay               ;critical delay !
pop dx
pop ax
retf
_dmastop endp

_dmacontinue proc far        ;Continue the DMA operation
push ax
push dx
mov al,0D4h                  ;Enable DSP
call writedsp
mov al,01h                   ;Enable DMA
out 0Ah,al
pop dx
pop ax
retf
_dmacontinue endp

_play proc far               ;playing
push bp
push ax
push bx
push cx
push dx
push si
push di
push ds
mov bp,sp
	   ;COPYING
push es
mov ax,[bp+22]               ;mem.pointer segment
mov ds,ax
mov si,[bp+20]               ;mem pointer offset
mov ax,[poi]
mov es,ax
mov di,0
cld
mov cx,[bp+24]               ;size
shr cx,1
rep movsw
pop es
	   ;RESET IT FLAG
mov ax,cs
mov ds,ax
mov al,0
mov [flag],al
	   ;DMA SETTING
mov al,05h                   ;[dmach]
out 0Ah,al                   ;mask reg.
mov al,0
out 0Ch,al                   ;Clear the internal DMA flip-flop
add al,49h
out 0Bh,al                   ;Mode reg.
mov ax,[poi]                 ;cmszmts
mov bx,16
mul bx                       ;dx:ax= lin cm
out 02h,al                   ;lin cm als 8 bit
mov al,ah
out 02h,al                   ;lin cm kv 8  bit
mov al,dl
out 83h,al                   ;page reg.
mov al,[bp+24]
out 03h,al                   ;size low
mov al,[bp+25]
out 03h,al                   ;size high
mov al,01h
out 0Ah,al                   ;mask reg = enable DMA
	      ;DSP SETTING
mov al,40h                   ;set the sample rate
call writedsp
mov dx,15
mov ax,16960
mov bx,[freq]
div bx
mov dx,256
sub dx,ax
mov al,dl
call writedsp                ; 256 - 1 000 000 Div Freq
mov al,14h                   ;8 bit playing with DMA
call writedsp
mov al,[bp+24]               ;size low
call writedsp
mov al,[bp+25]               ;size high
call writedsp
pop ds
pop di
pop si
pop dx
pop cx
pop bx
pop ax
pop bp
retf
_play endp

_allocate proc far           ;Allocate memory
push bp                      ;Returns NULL if error
push bx
mov bp,sp
mov ah,48h
mov bx,[bp+8]                ;size of block in paragraphs
int 21h
jc mhiba1
mov dx,ax
xor ax,ax
pop bx
pop bp
retf
mhiba1: xor ax,ax
xor dx,dx
pop bx
pop bp
retf
_allocate endp

_mrename proc far            ;Rename memory
push bp
push es
push bx
mov bp,sp
mov ax,[bp+12]              ;Blokk cme
mov bx,[bp+14]              ;Size
mov es,ax
mov ah,4Ah                   ;Returns 1 if error
int 21h
jc mhiba3
xor ax,ax
pop bx
pop es
pop bp
retf
mhiba3: mov ax,1
pop bx
pop es
pop bp
retf
_mrename endp

_mfree proc far              ;Free memory
push bp
push es
mov bp,sp
mov ax,[bp+10]               ;Blokk cme
mov es,ax
mov ah,49h                   ;Returns 1 if error
int 21h
jc mhiba2
xor ax,ax
pop es
pop bp
retf
mhiba2: mov ax,1
pop es
pop bp
retf
_mfree endp

_openr proc far              ;open a file to read
push ds
push dx
push bp
mov bp,sp
mov ax,[bp+12]               ;filename seg.
mov ds,ax
mov dx,[bp+10]               ;filename offs.
mov ax,3D00h
int 21h                      ;returns: AX=fileno
jc ferr1
mov dl,0
mov [fileerr],dl
jmp op1
ferr1:
mov dl,1
mov [fileerr],dl
op1:
pop bp
pop dx
pop ds
retf
_openr endp

_openw proc far              ;open a file to write
push ds
push dx
push cx
push bp
mov bp,sp
mov ax,[bp+14]               ;filename seg.
mov ds,ax
mov dx,[bp+12]               ;filename offs.
mov ax,3C00h
mov cx,0
int 21h                      ;returns: AX=fileno
jc ferr2
mov dl,0
mov [fileerr],dl
jmp op2
ferr2:
mov dl,1
mov [fileerr],dl
op2:
pop bp
pop cx
pop dx
pop ds
retf
_openw endp

_closefile proc far          ;close an opened file
push bx                      ;AX=1->hiba
push bp
mov bp,sp
mov ax,3E00h
mov bx,[bp+8]                ;Fileno
int 21h
jc ferr3
mov ax,0
pop bp
pop bx
retf
ferr3:
mov ax,1
pop bp
pop bx
retf
_closefile endp

_read proc far               ;read from a file
push bx
push ds
push dx
push cx
push bp
mov bp,sp
mov bx,[bp+14]               ;Fileno
mov ax,[bp+20]               ;buffer seg.
mov ds,ax
mov dx,[bp+18]               ;buffer offs.
mov cx,[bp+16]               ;size
mov ax,3F00h
int 21h
jc ferr4
mov bx,0
mov [fileerr],bl
jmp rd1
ferr4:
mov bx,1
mov [fileerr],bl
rd1:
pop bp
pop cx
pop dx
pop ds
pop bx
retf
_read endp

_write proc far               ;write to a file
push bx
push ds
push dx
push cx
push bp
mov bp,sp
mov bx,[bp+14]               ;Fileno
mov ax,[bp+20]               ;buffer seg.
mov ds,ax
mov dx,[bp+18]               ;buffer offs.
mov cx,[bp+16]               ;size
mov ax,4000h
int 21h
jc ferr5
mov bx,0
mov [fileerr],bl
jmp rd2
ferr5:
mov bx,1
mov [fileerr],bl
rd2:
pop bp
pop cx
pop dx
pop ds
pop bx
retf
_write endp

_ferr proc far               ;Ask if file open error occured
xor ax,ax
mov al,[fileerr]
retf
_ferr endp

end